From 897b27c273d302c2217319c5ff5de44024682846 Mon Sep 17 00:00:00 2001
From: Walter Doekes <walter+github@wjd.nu>
Date: Sat, 5 Sep 2015 23:08:09 +0200
Subject: [PATCH 07/15] Translate NUL to @ in incoming SMS.

Author: mio
Source: https://github.com/bg111/asterisk-chan-dongle/issues/153

Not using full 3GPP version from https://code.google.com/p/
  asterisk-chan-dongle/issues/detail?id=140 because of the issues
described there.

This should simply fix that you don't get a truncated SMS because of an
@ sign.
---
 char_conv.c | 9 +++++++++
 1 file changed, 9 insertions(+)

diff --git a/char_conv.c b/char_conv.c
index 3167f30..2a4be70 100644
--- a/char_conv.c
+++ b/char_conv.c
@@ -235,11 +235,20 @@ static ssize_t hexstr_7bit_to_char (const char* in, size_t in_length, char* out,
 		c = (c >> 1) | b;
 		b = ((unsigned char) hexval) >> (8 - s);
 
+		if (c == 0 && i + 1 < in_length) {
+			/* @ is encoded as NUL */
+			c = '@';
+		}
+
 		out[x] = c;
 		x++; s++;
 
 		if (s == 8)
 		{
+			if (b == 0 && i + 1 < in_length) {
+				/* @ is encoded as NUL */
+				b = '@';
+			}
 			out[x] = b;
 			s = 1; b = 0;
 			x++;

